# ABAQUS FE-MODEL
# FE-phyton-02.py

### ABAWUS MODULUS ###
from part import *
from material import *
from section import *
from assembly import *
from step import *
from interaction import *
from load import *
from mesh import *
from optimization import *
from job import *
from sketch import *
from visualization import *
from connectorBehavior import *

### GEOMETRY PARTS ###
mdb.models['Model-1'].ConstrainedSketch(name='__profile__', sheetSize=200.0)
mdb.models['Model-1'].sketches['__profile__'].Line(point1=(0.0, 5.0), point2=(
    0.0, 14.0))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((0.0, 9.5))
mdb.models['Model-1'].sketches['__profile__'].VerticalConstraint(addUndoState=
    False, entity=
    mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((0.0, 9.5), 
    ))
mdb.models['Model-1'].sketches['__profile__'].Line(point1=(0.0, 14.0), point2=(
    14.0, 14.0))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((7.0, 14.0))
mdb.models['Model-1'].sketches['__profile__'].HorizontalConstraint(
    addUndoState=False, entity=
    mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((7.0, 14.0), 
    ))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((0.0, 9.5))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((7.0, 14.0))
mdb.models['Model-1'].sketches['__profile__'].PerpendicularConstraint(
    addUndoState=False, entity1=
    mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((0.0, 9.5), )
    , entity2=mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((
    7.0, 14.0), ))
mdb.models['Model-1'].sketches['__profile__'].Line(point1=(14.0, 14.0), point2=
    (14.0, 0.0))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((14.0, 7.0))
mdb.models['Model-1'].sketches['__profile__'].VerticalConstraint(addUndoState=
    False, entity=
    mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((14.0, 7.0), 
    ))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((7.0, 14.0))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((14.0, 7.0))
mdb.models['Model-1'].sketches['__profile__'].PerpendicularConstraint(
    addUndoState=False, entity1=
    mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((7.0, 14.0), 
    ), entity2=mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((
    14.0, 7.0), ))
mdb.models['Model-1'].sketches['__profile__'].Line(point1=(14.0, 0.0), point2=(
    5.0, 0.0))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((9.5, 0.0))
mdb.models['Model-1'].sketches['__profile__'].HorizontalConstraint(
    addUndoState=False, entity=
    mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((9.5, 0.0), 
    ))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((14.0, 7.0))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((9.5, 0.0))
mdb.models['Model-1'].sketches['__profile__'].PerpendicularConstraint(
    addUndoState=False, entity1=
    mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((14.0, 7.0), 
    ), entity2=mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((
    9.5, 0.0), ))
mdb.models['Model-1'].sketches['__profile__'].ArcByCenterEnds(center=(0.0, 0.0)
    , direction=CLOCKWISE, point1=(0.0, 5.0), point2=(5.0, 0.0))
mdb.models['Model-1'].Part(dimensionality=TWO_D_PLANAR, name='Epoxy', type=
    DEFORMABLE_BODY)
mdb.models['Model-1'].parts['Epoxy'].BaseShell(sketch=
    mdb.models['Model-1'].sketches['__profile__'])
del mdb.models['Model-1'].sketches['__profile__']
mdb.models['Model-1'].ConstrainedSketch(name='__profile__', sheetSize=200.0)
mdb.models['Model-1'].sketches['__profile__'].Line(point1=(5.0, 0.0), point2=(
    0.0, 0.0))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((2.5, 0.0))
mdb.models['Model-1'].sketches['__profile__'].HorizontalConstraint(
    addUndoState=False, entity=
    mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((2.5, 0.0), 
    ))
mdb.models['Model-1'].sketches['__profile__'].Line(point1=(0.0, 0.0), point2=(
    0.0, 5.0))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((0.0, 2.5))
mdb.models['Model-1'].sketches['__profile__'].VerticalConstraint(addUndoState=
    False, entity=
    mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((0.0, 2.5), 
    ))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((2.5, 0.0))
mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((0.0, 2.5))
mdb.models['Model-1'].sketches['__profile__'].PerpendicularConstraint(
    addUndoState=False, entity1=
    mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((2.5, 0.0), )
    , entity2=mdb.models['Model-1'].sketches['__profile__'].geometry.findAt((
    0.0, 2.5), ))
mdb.models['Model-1'].sketches['__profile__'].ArcByCenterEnds(center=(0.0, 0.0)
    , direction=CLOCKWISE, point1=(5.0, 0.0), point2=(0.0, 5.0))
mdb.models['Model-1'].sketches['__profile__'].undo()
mdb.models['Model-1'].sketches['__profile__'].ArcByCenterEnds(center=(0.0, 0.0)
    , direction=CLOCKWISE, point1=(0.0, 5.0), point2=(5.0, 0.0))
mdb.models['Model-1'].Part(dimensionality=TWO_D_PLANAR, name='Fibre', type=
    DEFORMABLE_BODY)
mdb.models['Model-1'].parts['Fibre'].BaseShell(sketch=
    mdb.models['Model-1'].sketches['__profile__'])
del mdb.models['Model-1'].sketches['__profile__']

### MATERIAL AND SECTION ###
mdb.models['Model-1'].Material(name='Epoxy')
mdb.models['Model-1'].materials['Epoxy'].Elastic(table=((0.0039, 0.37), ))
mdb.models['Model-1'].materials['Epoxy'].MaxsDamageInitiation(table=((5e-05, 
    5e-05, 5e-05), ))
mdb.models['Model-1'].materials['Epoxy'].maxsDamageInitiation.DamageEvolution(
    mixedModeBehavior=POWER_LAW, power=1.0, table=((0.0005, 0.0005, 0.0005), ), 
    type=ENERGY)
mdb.models['Model-1'].materials['Epoxy'].maxsDamageInitiation.DamageStabilizationCohesive(
    cohesiveCoeff=1e-05)
mdb.models['Model-1'].Material(name='Fibre')
mdb.models['Model-1'].materials['Fibre'].Elastic(table=((0.0869, 0.23), ))
mdb.models['Model-1'].HomogeneousSolidSection(material='Fibre', name=
    'Fibre-section', thickness=None)
mdb.models['Model-1'].HomogeneousSolidSection(material='Epoxy', name=
    'Epoxy-section', thickness=None)
mdb.models['Model-1'].parts['Epoxy'].SectionAssignment(offset=0.0, offsetField=
    '', offsetType=MIDDLE_SURFACE, region=Region(
    faces=mdb.models['Model-1'].parts['Epoxy'].faces.findAt(((0.370868, 
    7.958213, 0.0), (0.0, 0.0, 1.0)), )), sectionName='Epoxy-section', 
    thicknessAssignment=FROM_SECTION)
mdb.models['Model-1'].parts['Fibre'].SectionAssignment(offset=0.0, offsetField=
    '', offsetType=MIDDLE_SURFACE, region=Region(
    faces=mdb.models['Model-1'].parts['Fibre'].faces.findAt(((3.316369, 
    0.237191, 0.0), (0.0, 0.0, 1.0)), )), sectionName='Fibre-section', 
    thicknessAssignment=FROM_SECTION)

### MESH ###
mdb.models['Model-1'].parts['Fibre'].seedEdgeByNumber(constraint=FINER, edges=
    mdb.models['Model-1'].parts['Fibre'].edges.findAt(((1.913417, 4.619398, 
    0.0), )), number=50)
mdb.models['Model-1'].parts['Fibre'].seedEdgeByBias(biasMethod=SINGLE, 
    constraint=FINER, end1Edges=
    mdb.models['Model-1'].parts['Fibre'].edges.findAt(((3.75, 0.0, 0.0), )), 
    end2Edges=mdb.models['Model-1'].parts['Fibre'].edges.findAt(((0.0, 1.25, 
    0.0), )), number=35, ratio=5.0)
mdb.models['Model-1'].parts['Fibre'].setElementType(elemTypes=(ElemType(
    elemCode=CPS4R, elemLibrary=STANDARD, secondOrderAccuracy=OFF, 
    hourglassControl=DEFAULT, distortionControl=DEFAULT), ElemType(
    elemCode=CPS3, elemLibrary=STANDARD)), regions=(
    mdb.models['Model-1'].parts['Fibre'].faces.findAt(((3.316369, 0.237191, 
    0.0), )), ))
mdb.models['Model-1'].parts['Fibre'].generateMesh()
mdb.models['Model-1'].parts['Epoxy'].seedEdgeByNumber(constraint=FINER, edges=
    mdb.models['Model-1'].parts['Epoxy'].edges.findAt(((1.913417, 4.619398, 
    0.0), )), number=50)
mdb.models['Model-1'].parts['Epoxy'].seedEdgeByBias(biasMethod=SINGLE, 
    constraint=FINER, end1Edges=
    mdb.models['Model-1'].parts['Epoxy'].edges.findAt(((0.0, 7.25, 0.0), )), 
    end2Edges=mdb.models['Model-1'].parts['Epoxy'].edges.findAt(((11.75, 0.0, 
    0.0), )), number=35, ratio=5.0)
mdb.models['Model-1'].parts['Epoxy'].seedEdgeByNumber(constraint=FINER, edges=
    mdb.models['Model-1'].parts['Epoxy'].edges.findAt(((14.0, 10.5, 0.0), ), ((
    3.5, 14.0, 0.0), ), ), number=25)
mdb.models['Model-1'].parts['Epoxy'].setElementType(elemTypes=(ElemType(
    elemCode=CPS4R, elemLibrary=STANDARD, secondOrderAccuracy=OFF, 
    hourglassControl=DEFAULT, distortionControl=DEFAULT), ElemType(
    elemCode=CPS3, elemLibrary=STANDARD)), regions=(
    mdb.models['Model-1'].parts['Epoxy'].faces.findAt(((0.370868, 7.958213, 
    0.0), )), ))
mdb.models['Model-1'].parts['Epoxy'].setMeshControls(elemShape=QUAD, regions=
    mdb.models['Model-1'].parts['Epoxy'].faces.findAt(((0.370868, 7.958213, 
    0.0), )))
mdb.models['Model-1'].parts['Epoxy'].generateMesh()

### SET & SURFACE ###
mdb.models['Model-1'].parts['Epoxy'].Surface(name='Right-Edge', side1Edges=
    mdb.models['Model-1'].parts['Epoxy'].edges.findAt(((14.0, 10.5, 0.0), )))
mdb.models['Model-1'].parts['Epoxy'].Set(edges=
    mdb.models['Model-1'].parts['Epoxy'].edges.findAt(((14.0, 10.5, 0.0), )), 
    name='Right-Edge')
mdb.models['Model-1'].parts['Epoxy'].Set(edges=
    mdb.models['Model-1'].parts['Epoxy'].edges.findAt(((0.0, 7.25, 0.0), )), 
    name='Left-Epoxy')
mdb.models['Model-1'].parts['Epoxy'].Set(edges=
    mdb.models['Model-1'].parts['Epoxy'].edges.findAt(((1.913417, 4.619398, 
    0.0), )), name='Boog-epoxy')
mdb.models['Model-1'].parts['Epoxy'].Set(edges=
    mdb.models['Model-1'].parts['Epoxy'].edges.findAt(((11.75, 0.0, 0.0), )), 
    name='Onder-epoxy')
mdb.models['Model-1'].parts['Fibre'].Set(edges=
    mdb.models['Model-1'].parts['Fibre'].edges.findAt(((1.913417, 4.619398, 
    0.0), )), name='Boog-Fibre')
mdb.models['Model-1'].parts['Fibre'].Set(edges=
    mdb.models['Model-1'].parts['Fibre'].edges.findAt(((0.0, 1.25, 0.0), )), 
    name='Left-Fibre')
mdb.models['Model-1'].parts['Fibre'].Set(edges=
    mdb.models['Model-1'].parts['Fibre'].edges.findAt(((3.75, 0.0, 0.0), )), 
    name='Onder-Fibre')

### CONTACT ###
mdb.models['Model-1'].rootAssembly.DatumCsysByDefault(CARTESIAN)
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Epoxy-1', part=
    mdb.models['Model-1'].parts['Epoxy'])
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Fibre-1', part=
    mdb.models['Model-1'].parts['Fibre'])
mdb.models['Model-1'].ContactProperty('Cohesive')
mdb.models['Model-1'].interactionProperties['Cohesive'].CohesiveBehavior(
    defaultPenalties=OFF, table=((0.1, 0.1, 0.1), ))
mdb.models['Model-1'].interactionProperties['Cohesive'].Damage(evolTable=((
    0.0005, 0.0005, 0.0005), ), evolutionType=ENERGY, exponent=1.0, initTable=(
    (2.5e-05, 2.5e-05, 2.5e-05), ), mixedModeType=POWER_LAW, useEvolution=ON, 
    useMixedMode=ON, useStabilization=ON, viscosityCoef=1e-05)
mdb.models['Model-1'].parts['Epoxy'].Surface(name='Boog-Epoxy', side1Edges=
    mdb.models['Model-1'].parts['Epoxy'].edges.findAt(((1.913417, 4.619398, 
    0.0), )))
mdb.models['Model-1'].parts['Fibre'].Surface(name='Boog-Fibre', side1Edges=
    mdb.models['Model-1'].parts['Fibre'].edges.findAt(((1.913417, 4.619398, 
    0.0), )))
mdb.models['Model-1'].rootAssembly.regenerate()
mdb.models['Model-1'].SurfaceToSurfaceContactStd(adjustMethod=OVERCLOSED, 
    clearanceRegion=None, createStepName='Initial', datumAxis=None, 
    enforcement=NODE_TO_SURFACE, initialClearance=OMIT, interactionProperty=
    'Cohesive', master=
    mdb.models['Model-1'].rootAssembly.instances['Epoxy-1'].surfaces['Boog-Epoxy']
    , name='Cohesive-interface', slave=
    mdb.models['Model-1'].rootAssembly.instances['Fibre-1'].surfaces['Boog-Fibre']
    , sliding=FINITE, smooth=0.2, surfaceSmoothing=NONE, thickness=OFF, tied=
    OFF)

### XFEM CRACK ###
mdb.models['Model-1'].rootAssembly.engineeringFeatures.XFEMCrack(crackDomain=
    Region(
    faces=mdb.models['Model-1'].rootAssembly.instances['Epoxy-1'].faces.findAt(
    ((0.370868, 7.958213, 0.0), (0.0, 0.0, 1.0)), )), name='Crack-XFEM')
mdb.models['Model-1'].XFEMCrackGrowth(crackName='Crack-XFEM', createStepName=
    'Initial', name='Crack-Growth')

### STEP ###
mdb.models['Model-1'].StaticStep(adaptiveDampingRatio=0.1, 
    continueDampingFactors=False, initialInc=0.01, maxInc=0.01, maxNumInc=
    1000000, minInc=1e-35, name='Loading', nlgeom=ON, previous='Initial', 
    stabilizationMagnitude=0.0005, stabilizationMethod=
    DISSIPATED_ENERGY_FRACTION)
mdb.models['Model-1'].steps['Loading'].control.setValues(allowPropagation=OFF, 
    discontinuous=ON, resetDefaultValues=OFF, timeIncrementation=(8.0, 10.0, 
    9.0, 16.0, 10.0, 4.0, 12.0, 100.0, 6.0, 3.0, 50.0))

### BC's ###
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Initial', 
    distributionType=UNIFORM, fieldName='', localCsys=None, name='Rol-X-Fibre', 
    region=
    mdb.models['Model-1'].rootAssembly.instances['Fibre-1'].sets['Left-Fibre'], 
    u1=SET, u2=UNSET, ur3=UNSET)
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Initial', 
    distributionType=UNIFORM, fieldName='', localCsys=None, name='Rol-X-Epoxy', 
    region=
    mdb.models['Model-1'].rootAssembly.instances['Epoxy-1'].sets['Left-Epoxy'], 
    u1=SET, u2=UNSET, ur3=UNSET)
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Initial', 
    distributionType=UNIFORM, fieldName='', localCsys=None, name='Rol-Y-Fibre', 
    region=
    mdb.models['Model-1'].rootAssembly.instances['Fibre-1'].sets['Onder-Fibre']
    , u1=UNSET, u2=SET, ur3=UNSET)
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Initial', 
    distributionType=UNIFORM, fieldName='', localCsys=None, name='Rol-Y-Epoxy', 
    region=
    mdb.models['Model-1'].rootAssembly.instances['Epoxy-1'].sets['Onder-epoxy']
    , u1=UNSET, u2=SET, ur3=UNSET)

### Displacement ###
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Loading', 
    distributionType=UNIFORM, fieldName='', fixed=OFF, localCsys=None, name=
    'Displacement', region=
    mdb.models['Model-1'].rootAssembly.instances['Epoxy-1'].sets['Right-Edge'], 
    u1=5.0, u2=UNSET, ur3=UNSET)

### JOB ###
mdb.Job(atTime=None, contactPrint=OFF, description='', echoPrint=OFF, 
    explicitPrecision=SINGLE, getMemoryFromAnalysis=True, historyPrint=OFF, 
    memory=90, memoryUnits=PERCENTAGE, model='Model-1', modelPrint=OFF, 
    multiprocessingMode=DEFAULT, name='FE-phyton-02', nodalOutputPrecision=
    SINGLE, numCpus=4, numDomains=4, queue=None, scratch='', type=ANALYSIS, 
    userSubroutine='', waitHours=0, waitMinutes=0)

### CALCULATE ###
mdb.jobs['FE-phyton-02'].submit(consistencyChecking=OFF)

